import { Component, ComponentClass, FunctionComponent } from 'react';
declare type ErrorType = string;
export interface LoaderProps {
    isLoading: boolean;
    error: ErrorType;
}
declare type Loader = FunctionComponent<LoaderProps> | ComponentClass<LoaderProps> | string;
export interface PropsTypes {
    user: string;
    hash: string;
    defaultTab: string;
    height: number;
    preview: boolean;
    themeId: string | number;
    version: number;
    shouldLoadScript: boolean;
    loader?: Loader;
    title?: string;
    overrideAsLoaded?: boolean;
    isLoaded: boolean;
    isLoading: boolean;
    error?: ErrorType;
}
export interface ReactCodepenProps extends Pick<PropsTypes, "user" | "hash" | "defaultTab" | "height" | "preview" | "themeId" | "version" | "loader" | "title" | "shouldLoadScript" | "overrideAsLoaded"> {
}
interface ReactCodepenState {
    loaded: boolean;
    loading: boolean;
    error?: ErrorType;
}
declare class ReactCodepen extends Component<ReactCodepenProps, ReactCodepenState> {
    private _mounted;
    private scriptTagBuilder;
    static defaultProps: {
        defaultTab: string;
        height: number;
        preview: boolean;
        themeId: string;
        version: number;
        shouldLoadScript: boolean;
    };
    state: {
        loaded: boolean;
        loading: boolean;
        error: any;
    };
    constructor(props: ReactCodepenProps, context: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private isLoaded;
    private handleScriptLoad;
    private handleScriptError;
}
export default ReactCodepen;
